DEFINE CLASS RandFunctions AS Custom

PROCEDURE Init

* Seed Rand()
RAND(-1)

ENDPROC

PROCEDURE RandInt (nMin as Integer, ;
                   nMax as Integer) as Integer
* Return a random integer between 0 and the specified max

LOCAL nRand, nResult

IF VARTYPE(nMin)<>"N"
	nMin = 0
ENDIF

IF VARTYPE(nMax)<> "N"
	nMax = 1
ENDIF 

nRand = RAND()
nResult = INT((nMax - nMin + 1) * nRand) + nMin

RETURN nResult
ENDPROC

PROCEDURE RandLetter
* Return a randomly selected letter of the alphabet

LOCAL nRand, cLetter

nRand = This.RandInt(1, 26)
cLetter = CHR(64 + nRand)

RETURN cLetter
ENDPROC

PROCEDURE RandRecord(cAlias, cField)
* Choose a record at random from an existing table and
* return the value of the specified field

LOCAL nRecord, uReturn, nOldRecNo

TRY
	nRecord = This.RandInt(1, RECCOUNT(m.cAlias))
	GO (m.nRecord) IN (m.cAlias)
	STORE EVALUATE(m.cAlias + "." + m.cField) TO uReturn
CATCH
	uReturn = .null.
ENDTRY

RETURN uReturn
ENDPROC 

ENDDEFINE
